$APPTYPE GUI
$TYPECHECK ON
$INCLUDE "RAPIDQ1.INC"
$INCLUDE "RAPIDQ2.INC"
$INCLUDE "XP_MANIFEST.INC"
CONST MyformName = "RQ-Pretty 1.2"
CONST MyformBuild = "10.04.2010"        '-- Bitte immer updaten !!!
CONST myFormTitle = "  RQ-Pretty"
$XP_MANIFEST(LEFT$(MyformName , LEN(MyformName) - 4) , RIGHT$(MyformName , 3) + ".0.0" , myFormTitle + " (Build " + MyformBuild + ")")
$INCLUDE "Standard.inc"
$INCLUDE "QWinIni.INC"

$RESOURCE Sopen_bmp AS "R:\RapidQ\basfiles\rq-pretty\open4.bmp"
$RESOURCE Ssave_bmp AS "R:\RapidQ\basfiles\rq-pretty\save4.bmp"
$RESOURCE Ssaveas_bmp AS "R:\RapidQ\basfiles\rq-pretty\saveas4.bmp"
$RESOURCE Sdoor_bmp AS "R:\RapidQ\basfiles\rq-pretty\exit4.bmp"
$RESOURCE Srun_bmp AS "R:\RapidQ\basfiles\rq-pretty\Lrun1.bmp"
$RESOURCE Shelp_bmp AS "R:\RapidQ\basfiles\rq-pretty\help4.bmp"
$RESOURCE Logo_bmp AS "R:\RapidQ\basfiles\rq-pretty\vd.bmp"
$INCLUDE "AboutForm.INC"
$INCLUDE "CalcDate.INC"

DEFBYTE Automatik = False , Beautify = False , Filled = False , gef = 0 , OneTab = False
DEFSTR Filename , TFilename , BFilename , Spacepart , Line1 , Commentpart , Teststr        ', Tabulator = CHR$(9)
DEFSTR Tabpart = "" , TmpStr$ , PosStr$ , e$ , Language , ListText , RunText , TransText ' , test(3) = {"0" , "1" , "2" , "3"}
DEFLNG a , b , c , d , LC , SubStrFound = 0
DEFWORD spacenumber , spacenumberC

DIM Timer1 AS QTIMER
DIM FileDialog AS Qfiledialog
DIM File AS QFILESTREAM
DIM mem AS QMEMORYSTREAM
DIM mem1 AS QMEMORYSTREAM
DIM StrList AS QSTRINGLIST
DIM DimList AS QSTRINGLIST
DIM PosList AS QSTRINGLIST
DIM LogFile AS QFILESTREAM
DIM LstFile AS QFILESTREAM

IF Command$(1) > "" THEN
    Filename = Command$(1)
    IF FILEEXISTS(Filename) = 0 THEN
        Filename = ""
    ELSE
        Filled = True
    END IF
END IF
TFilename = Filename
BFilename = Filename + IIF(Filename > "" , ".BAK" , "")
IF Command$(2) > "" THEN
    Line1 = UCASE$(LEFT$(REPLACESUBSTR$(LTRIM$(Command$(2)) , "/" , "-") , 2))
    IF Line1 = "-Q" THEN Automatik = True
END IF

DECLARE FUNCTION URLDownloadToCacheFile LIB "urlmon" ALIAS "URLDownloadToCacheFileA"(Ucaller AS LONG , _
    szURL AS STRING , byref szFileName AS STRING , BufLen AS LONG , dwRes AS LONG , Status AS LONG) AS LONG
DECLARE FUNCTION GetLocaleInfo LIB "kernel32" ALIAS "GetLocaleInfoA"(Locale AS LONG , LCType AS LONG , pLCData AS LONG , cchData AS LONG) AS LONG
      'DECLARE FUNCTION SetFocus LIB "User32" ALIAS "SetFocus"(hwnd AS LONG)AS LONG
DECLARE FUNCTION SubstSubstr(byref Mainstring AS STRING , Orgstring AS STRING , Sparestring AS STRING , BigL AS INTEGER) AS STRING
DECLARE SUB Killspaces(t$ AS STRING)
DECLARE SUB StartBtnClick(Sender AS QCOOLBTN)
DECLARE SUB OpenClick
DECLARE SUB SaveClick
DECLARE SUB SaveasClick
DECLARE SUB AboutClick
DECLARE SUB CheckbClick
DECLARE SUB LChange
DECLARE SUB ExitClick
DECLARE SUB Exit_Click
DECLARE SUB Translate
DECLARE SUB Focus

CREATE Form AS QFORM
    Caption = myFormTitle
    Width = 480
    Height = 265
    BorderStyle = bsSingle
    DelBorderIcons(biMaximize)
    OnClose = ExitClick
    CREATE MainMenu AS QMAINMENU
        CREATE mnuAbout AS QMENUITEM
            Visible = False
            OnClick = AboutClick
            ShortCut = "F1"
        END CREATE
    END CREATE
    CREATE panelButton AS QPANEL
        Top = 5
        Left = 5
        Height = 32
        Width = 463
        ShowHint = True
        CREATE buttonExit AS QBUTTON
            Top = 3
            Left = 3
            Height = 26
            Width = 26
            BMPHandle = Sdoor_bmp
            OnClick = Exit_Click
        END CREATE
        CREATE Tschau AS QBUTTON
            Left = 3
            Top = 3
            Width = 0
            Kind = bkCancel
            Caption = "&E"
            TabOrder = - 1
        END CREATE
        CREATE buttonOpen AS QBUTTON
            Top = 3
            Left = 32
            Height = 26
            Width = 26
            BMPHandle = Sopen_bmp
            OnClick = OpenClick
        END CREATE
        CREATE OrgOpen AS QBUTTON
            Left = 32
            Top = 3
            Width = 0
            Caption = "&O"
            OnClick = OpenClick
            TabOrder = - 1
        END CREATE
        CREATE buttonSave AS QBUTTON
            Top = 3
            Left = 61
            Height = 26
            Width = 26
            BMPHandle = Ssave_bmp
            OnClick = SaveClick
        END CREATE
        CREATE SaveOpen AS QBUTTON
            Left = 61
            Top = 3
            Width = 0
            Caption = "&T"
            OnClick = SaveClick
            TabOrder = - 1
        END CREATE
        CREATE buttonSaveAs AS QBUTTON
            Top = 3
            Left = 90
            Height = 26
            Width = 26
            BMPHandle = Ssaveas_bmp
            Enabled = False
            OnClick = SaveasClick
        END CREATE
        CREATE SaveAsOpen AS QBUTTON
            Left = 90
            Top = 3
            Width = 0
            Caption = "&B"
            Enabled = False
            OnClick = SaveasClick
            TabOrder = - 1
        END CREATE
        CREATE buttonAbout AS QBUTTON
            Top = 3
            Left = 119
            Height = 26
            Width = 26
                  'Caption="?"
            BMPHandle = Shelp_bmp
            OnClick = AboutClick
        END CREATE
        CREATE AboutOpen AS QBUTTON
            Left = 119
            Top = 3
            Width = 0
            Caption = "&?"
            OnClick = AboutClick
            TabOrder = - 1
        END CREATE
        CREATE Labeltxt AS QLABEL
            Left = 155
            Top = 7
            Width = 59
            Height = 20
            Alignment = 1
        END CREATE
        CREATE Paneltxt AS QCOMBOBOX
            Left = 220
            Top = 4
            Width = 120
            Height = 20
            ShowHint = True
            DropDownCount = 12
            OnChange = LChange
        END CREATE
        CREATE startbutton AS QBUTTON
            Top = 3
            Left = 360
            Width = 100
            Height = 26
            Enabled = False
            BMPHandle = Srun_bmp
                  'Caption = "Start"
            OnClick = StartBtnClick
            Default = True
        END CREATE
    END CREATE
    CREATE PanelRO AS QGROUPBOX
        Left = 5
        Top = 40
        Width = 463
        Height = 100
              'BorderStyle = bsSingle
        ShowHint = True
        CREATE LabelO AS QLABEL
                  'Caption = "Org-File:"
            Left = 10
            Top = 14
            Width = 80
            Height = 20
        END CREATE
        CREATE PanelO AS QPANEL
            Caption = Filename
            Left = 95
            Top = 13
            Width = 355
            Height = 20
            Color = 16777215
            Alignment = taLeftJustify
            OnClick = OpenClick
        END CREATE
        CREATE LabelT AS QLABEL
                  'Caption = "Target-File:"
            Left = 10
            Top = 44
            Width = 80
            Height = 20
        END CREATE
        CREATE PanelT AS QPANEL
            Caption = TFilename
            Left = 95
            Top = 43
            Width = 355
            Height = 20
            Color = 16777215
            Alignment = taLeftJustify
            OnClick = SaveClick
        END CREATE
        CREATE LabelB AS QLABEL
                  'Caption = "Backup-File:"
            Left = 10
            Top = 74
            Width = 80
            Height = 20
        END CREATE
        CREATE PanelB AS QPANEL
            Caption = BFilename
            Left = 95
            Top = 73
            Width = 355
            Height = 20
            Color = 16777215
            Alignment = taLeftJustify
            OnClick = SaveasClick
        END CREATE
    END CREATE
    CREATE PanelRS AS QGROUPBOX
        Left = 5
        Top = 145
        Width = 463
        Height = 62
        CREATE EditS AS QEDIT
            Text = "4"
            Left = 10
            Top = 13
            Width = 20
        END CREATE
        CREATE LabelS AS QLABEL
                  'Caption = "Spaces replace one Tab"
            Left = 35
            Top = 16
            Width = 150
            Height = 20
        END CREATE
        CREATE EditC AS QEDIT
            Text = "6"
            Left = 220
            Top = 13
            Width = 20
        END CREATE
        CREATE LabelC AS QLABEL
                  'Caption = "Spaces for intending Comments"
            Left = 245
            Top = 16
            Width = 200
            Height = 20
        END CREATE
        CREATE CheckB AS QCHECKBOX
                  'Caption = "Backup Org-File"
            Left = 10        '12
            Top = 38
            Width = 130
            Checked = True
            OnClick = CheckbClick
        END CREATE
        CREATE CheckL AS QCHECKBOX
                  'Caption = "Generate LST-File"
            Left = 140        '12
            Top = 38
            Width = 135
            Checked = True
            OnClick = CheckbClick
        END CREATE
        CREATE CheckE AS QCHECKBOX
                  'Caption = "Save Options"
            Left = 277
            Top = 38
            Width = 180
            Checked = True
            OnClick = Focus
        END CREATE
    END CREATE
    CREATE StatusBar AS QSTATUSBAR
        AddPanels "   Make your choices and press the Start-Button"
        SizeGrip = False
    END CREATE
END CREATE

SUB IniTest(Eintrag AS STRING , Wert AS STRING)
    IF Ini.get("English" , Eintrag , "") = "" THEN Ini.Write("English" , Eintrag , Wert)
END SUB

Line1 = Command$(0)
Line1 = LEFT$(Line1 , RINSTR(Line1 , ".")) + "ini"
Ini.File = Line1
IF Ini.load() <> 1 THEN
    Ini.Write("RQpretty" , "Language" , "English")
    Ini.Write("RQpretty" , "Reminder" , "*!*")
    Ini.Write("Deutsch" , "BasFilter" , "RapidQ-Dateien (*.BAS,*.RQB,*.INC)|*.BAS;*.RQB;*.INC|Alle Dateien(*.*)|*.*")
    Ini.load()
END IF
IF Ini.Get("RQpretty" , "German" , "") = "" THEN Ini.Write("RQpretty" , "German" , "Deutsch")
IF Ini.Get("Deutsch" , "Donetext" , "") = "" THEN Ini.Write("Deutsch" , "DoneText" , "Fertig.")
IF (Ini.Getraw("RQpretty" , "Portuguese" , "") = "") AND (Ini.Get("Portugues-BR" , "StartText" , "") > "") THEN Ini.Write("RQpretty" , "Portuguese" , "Portugues-BR")
IniTest("HintExit" , "Exit program")
IniTest("HintOrg" , "Change Org-File")
IniTest("HintTarget" , "Change Target-File")
IniTest("HintBak" , "Change Backup-File")
IniTest("HintAbout" , "About RQ-Pretty")
IniTest("HintLanguage" , "Change the language")
IniTest("LanguageText" , "Language:")
IniTest("StartText" , "Start")
IniTest("OrgText" , "Org-File:")
IniTest("TargetText" , "Target-File:")
IniTest("BackupText" , "Backup-File:")
IniTest("TabText" , "Spaces replace one Tab")
IniTest("CommentText" , "Spaces for intending Comments")
IniTest("BackupCheck" , "Backup Org-File")
IniTest("LstCheck" , "Generate LST-File")
IniTest("OptionsCheck" , "Save Options")
IniTest("StatusText" , "Make your choices and press the Start-Button")
IniTest("AbortText" , "Do you really want to abort this program now ?")
IniTest("DialogOpen" , "Open File ...")
IniTest("DialogSave" , "Save File as ...")
IniTest("BasFilter" , "RapidQ-Files (*.BAS,*.RQB,*.INC)|*.BAS;*.RQB;*.INC|All Files(*.*)|*.*")
IniTest("BakFilter" , "BAK-Files (*.BAK)|*.BAK|All Files(*.*)|*.*")
IniTest("AboutCaption" , "About")
IniTest("BuildOn" , "Build on")
IniTest("AboutFree" , "This program is Freeware.")
IniTest("AboutTranslate" , "English translation by V. Dobiasch")
IniTest("About1Text" , "This program beautifies your source-code.")
IniTest("About2Text" , "(Same writing of variables and keywords, tabs etc.)")
IniTest("About3Text" , "Commandline: RQ-Pretty [Bas-File] [/QUIET]")
IniTest("About4Text" , "You use this program on your own risk. The programmer")
IniTest("About5Text" , "is never responsible for any damage or costs.")
IniTest("NewVersionCaption" , "There is a newer Version in Internet !")
IniTest("NewVersion1Caption" , "Version")
IniTest("NewVersion2Caption" , "build on")
IniTest("ActVersionCaption" , "You already use the newest Version.")
IniTest("NoVersionCaption" , "No Versioninfo found in Internet !")
IniTest("NoConnectCaption" , "No connection to the Update-Server !")
IniTest("PrepareText" , "Please wait ... Preparing files")
IniTest("ListText" , "Needed Keywordlist %1%LST is missing !")
IniTest("RunText" , "Please wait ... Beautifying Line %1% of %2%")
IniTest("SaveText" , "Please wait ... Saving beautified file")
IniTest("DoneText" , "Done.")

IF VAL(Ini.Get("RQpretty" , "Top" , "-1")) < 0 THEN
    Form.Center
ELSE
    Form.Top = VAL(Ini.Get("RQpretty" , "Top" , "0"))
    Form.Left = VAL(Ini.Get("RQpretty" , "Left" , "0"))
END IF
EditS.Text = Ini.Get("RQpretty" , "SpaceTab" , "4")
EditC.Text = Ini.Get("RQpretty" , "SpaceComment" , "6")
Line1 = Ini.Get("RQpretty" , "Backup" , "Y")
Line1 = UCASE$(LEFT$(Line1 , 1))
CheckB.Checked = IIF(Line1 = "J" OR Line1 = "Y" , True , False)
CheckbClick
Line1 = Ini.Get("RQpretty" , "LSTfile" , "Y")
Line1 = UCASE$(LEFT$(Line1 , 1))
CheckL.Checked = IIF(Line1 = "J" OR Line1 = "Y" , True , False)
Line1 = Ini.Get("RQpretty" , "Options" , "Y")
Line1 = UCASE$(LEFT$(Line1 , 1))
CheckE.Checked = IIF(Line1 = "J" OR Line1 = "Y" , True , False)
Line1 = Ini.GetsectionNames()
Paneltxt.Clear
WHILE INSTR(Line1 , CHR$(0)) > 0
    IF UCASE$(LEFT$(Line1 , INSTR(Line1 , CHR$(0)) - 1)) <> "RQPRETTY" THEN Paneltxt.AddItems LEFT$(Line1 , INSTR(Line1 , CHR$(0)) - 1)
    Line1 = MID$(Line1 , INSTR(Line1 , CHR$(0)) + 1)
WEND
Line1 = STRING$(100 , 0)
a = GetLocaleInfo(&H400 , 4097 , VARPTR(Line1) , LEN(Line1))
Line1 = IIF(a > 0 , LEFT$(Line1 , a - 1) , "English")
TransText = " (User-Lang-ID: " + Line1 + ") "
'Paneltxt.Text = Ini.Get("RQpretty" , "Language" , "")
'IF LTRIM$(Paneltxt.Text) = "" THEN Paneltxt.Text = "Unknown"
Paneltxt.Text = Ini.Getraw("RQpretty" , "Language" , TransText)
IF Paneltxt.ItemCount > 0 THEN
    b = - 1
    a = 0
    DO
        IF UCASE$(Paneltxt.Item(a)) = UCASE$(Paneltxt.Text) THEN b = a
        a ++
    LOOP UNTIL b > - 1 OR a >= Paneltxt.ItemCount
    IF b = - 1 THEN
        Paneltxt.Text = Ini.Get("RQpretty" , Line1 , "English")
    ELSE
        Paneltxt.ItemIndex = b
    END IF
END IF
LChange

IF Filled THEN
    startbutton.Enabled = True
    Focus
    Timer1.OnTimer = StartBtnClick
    Timer1.Interval = 100
    Timer1.Enabled = Automatik
ELSE
    Timer1.OnTimer = OpenClick
    Timer1.Interval = 100
    Timer1.Enabled = True
END IF

SETWINDOWLONG Form.Handle , - 8 , 0
SETWINDOWLONG APPLICATION.Handle , - 8 , Form.Handle
Form.ShowModal

      '---------Subroutines---------
SUB ExitClick
    WHILE Beautify DO
        IF MESSAGEBOX(Ini.Get(Language , "AbortText" , "Wollen Sie das Programm wirklich jetzt abbrechen ?") , MyformName , 36) = mrYes THEN
            Beautify = False
        ELSE
            SLEEP 30
        END IF
              'never end while beautify-process is running
    WEND
    Ini.Write("RQpretty" , "Options" , IIF(CheckE.Checked = True , "Y" , "N"))
    IF CheckE.Checked THEN
        Ini.Write("RQpretty" , "Top" , STR$(Form.Top))
        Ini.Write("RQpretty" , "Left" , STR$(Form.Left))
        Ini.Write("RQpretty" , "Backup" , IIF(CheckB.Checked = True , "Y" , "N"))
        Ini.Write("RQpretty" , "LSTfile" , IIF(CheckL.Checked = True , "Y" , "N"))
        Ini.Write("RQpretty" , "SpaceTab" , EditS.Text)
        Ini.Write("RQpretty" , "SpaceComment" , EditC.Text)
        Ini.Write("RQpretty" , "Language" , Paneltxt.Text)
    END IF
END SUB

SUB Exit_Click
    Form.Close
END SUB

SUB LChange
    Language = Paneltxt.Text
    buttonExit.Hint = Ini.Get(Language , "HintExit" , "Programm beenden") + "  (ESC)"
    buttonOpen.Hint = Ini.Get(Language , "HintOrg" , "Whle die Orginal-Datei aus") + "  (O)"
    PanelO.Hint = buttonOpen.Hint
    buttonSave.Hint = Ini.Get(Language , "HintTarget" , "Whle die Ziel-Datei aus") + "  (T)"
    PanelT.Hint = buttonSave.Hint
    buttonSaveAs.Hint = Ini.Get(Language , "HintBak" , "Whle die Backup-Datei aus") + "  (B)"
    PanelB.Hint = buttonSaveAs.Hint
    buttonAbout.Hint = Ini.Get(Language , "HintAbout" , "ber RQ-Pretty") + "  (?)"
    Paneltxt.Hint = Ini.Get(Language , "HintLanguage" , "Whle die Sprache aus")
    Labeltxt.Caption = Ini.Get(Language , "LanguageText" , "Sprache:")
    startbutton.Caption = Ini.Get(Language , "StartText" , "&Start")
    LabelO.Caption = Ini.Get(Language , "OrgText" , "Orginal-Datei:")
    LabelT.Caption = Ini.Get(Language , "TargetText" , "Ziel-Datei:")
    LabelB.Caption = Ini.Get(Language , "BackupText" , "Backup-Datei:")
    LabelS.Caption = Ini.Get(Language , "TabText" , "Leerzeichen ersetzen ein Tab")
    LabelC.Caption = Ini.Get(Language , "CommentText" , "Leerzeichen vor Kommentaren")
    CheckB.Caption = Ini.Get(Language , "BackupCheck" , "Sichere Orginal-Datei")
    CheckL.Caption = Ini.Get(Language , "LstCheck" , "Erzeuge LST-Datei")
    CheckE.Caption = Ini.Get(Language , "OptionsCheck" , "Speichere diese Einstellungen")
    StatusBar.Panel(0).Caption = "   " + Ini.Get(Language , "StatusText" , "Treffen Sie Ihre Wahl und drcken dann den Start-Knopf")
    ListText = Ini.Getraw(Language , "ListText" , "Bentigte Schlsselwort-Liste %1%LST fehlt !")
    RunText = Ini.Getraw(Language , "RunText" , "Bitte warten ... berarbeite Zeile %1% von %2%")
    Form.Repaint
    Focus
END SUB

SUB Translate
    DEFSTR trans1 = ""
    FileDialog.Parent = Form.Handle
    FileDialog.Mode = 1
    FileDialog.Caption = "Save Translation-File as ..."
    FileDialog.Filter = "Language-File(*.lng)|*.lng|All Files|*.*"
    FileDialog.DefaultExt = "lng"
    FileDialog.FilterIndex = 1
    FileDialog.MultiSelect = 0
    FileDialog.InitialDir = CurDir$
    FileDialog.Filename = ""
    trans1 = Ini.Getsection("English")
    IF FileDialog.Execute = True AND trans1 <> "" THEN
        File.Open(FileDialog.Filename , fmCreate)
        File.WriteLine(";" + MyformName + " Languagefile " + TransText)
        File.WriteLine("; Don't touch the first line !")
        File.WriteLine(";")
        File.WriteLine("[English]   ;Please translate this and all following right of =")
        WHILE INSTR(trans1 , CHR$(0)) > 0
            File.WriteLine(LEFT$(trans1 , INSTR(trans1 , CHR$(0)) - 1))
            trans1 = MID$(trans1 , INSTR(trans1 , CHR$(0)) + 1)
        WEND
        File.WriteLine("; Thank you for translating.")
        File.WriteLine("; For testing, you can append the translated section to your LNG-File.")
        File.WriteLine("; Please send this translated file by email to soft@vdobiasch.2ya.de")
        File.Close
        MESSAGEBOX("Please send the translated file by email to" + CHR$(13) + CHR$(10) + CHR$(10) + CHR$(9) + "soft@vdobiasch.2ya.de" , "Thank you for translating." , 64)
    END IF
    setfocus(aboutform.Handle)
END SUB

SUB CheckbClick
    IF Beautify = False THEN
        IF CheckB.Checked THEN
            LabelB.Enabled = True
            PanelB.BevelOuter = bvRaised
            PanelB.Color = 16777215
            buttonSaveAs.Enabled = True
            SaveAsOpen.Enabled = True
        ELSE
            LabelB.Enabled = False
            PanelB.BevelOuter = bvNone
            PanelB.Color = LabelB.Color
            buttonSaveAs.Enabled = False
            SaveAsOpen.Enabled = False
        END IF
        panelButton.Repaint
        Focus
    END IF
END SUB

SUB Focus
    SetFocus(IIF(startbutton.Enabled = True , startbutton.Handle , buttonExit.Handle))
END SUB

SUB OpenClick
    Timer1.Enabled = False
    IF Beautify = False THEN
        FileDialog.Parent = Form.Handle
        FileDialog.Mode = 0
        FileDialog.Caption = Ini.get(Language , "DialogOpen" , "Datei ffnen ...")
        FileDialog.Filter = Ini.Getraw(Language , "BasFilter" , "RapidQ-Dateien (*.BAS,*.RQB,*.INC)|*.BAS;*.RQB;*.INC|Alle Dateien(*.*)|*.*")
        FileDialog.FilterIndex = 1
        FileDialog.MultiSelect = 0
        FileDialog.InitialDir = CurDir$
        FileDialog.Filename = ""
        IF FileDialog.Execute THEN
            Filename = FileDialog.Filename
            PanelO.Caption = Filename
            TFilename = Filename
            PanelT.Caption = TFilename
            BFilename = Filename + ".BAK"
            PanelB.Caption = BFilename
            Filled = True
            StatusBar.Panel(0).Caption = "   " + Ini.Get(Language , "StatusText" , "Treffen Sie Ihre Wahl und drcken dann den Start-Knopf")
            startbutton.Enabled = True
        END IF
        Focus
    END IF
END SUB

SUB SaveClick
    IF Beautify = False THEN
        FileDialog.Parent = Form.Handle
        FileDialog.Mode = 1
        FileDialog.Caption = Ini.get(Language , "DialogSave" , "Datei speichern unter ...")
        FileDialog.Filter = Ini.Getraw(Language , "BasFilter" , "RapidQ-Dateien (*.BAS,*.RQB,*.INC)|*.BAS;*.RQB;*.INC|Alle Dateien(*.*)|*.*")
        FileDialog.FilterIndex = 1
        FileDialog.DefaultExt = "rqb"
        FileDialog.MultiSelect = 0
        FileDialog.InitialDir = CurDir$
        FileDialog.Filename = ""
        IF TFilename <> "" THEN FileDialog.Filename = TFilename
        IF FileDialog.Execute THEN
            TFilename = FileDialog.Filename
            PanelT.Caption = TFilename
        END IF
        Focus
    END IF
END SUB

SUB SaveasClick
    IF Beautify = False THEN
        FileDialog.Parent = Form.Handle
        FileDialog.Mode = 1
        FileDialog.Caption = Ini.get(Language , "DialogSave" , "Datei speichern unter ...")
        FileDialog.Filter = Ini.Getraw(Language , "BakFilter" , "Sicherungs-Dateien (*.BAK)|*.BAK|Alle Dateien(*.*)|*.*")
        FileDialog.FilterIndex = 1
        FileDialog.MultiSelect = 0
        FileDialog.DefaultExt = "bak"
        FileDialog.InitialDir = CurDir$
        FileDialog.Filename = ""
        IF BFilename <> "" THEN FileDialog.Filename = BFilename
        IF FileDialog.Execute THEN
            BFilename = FileDialog.Filename
            PanelB.Caption = BFilename
        END IF
        Focus
    END IF
END SUB

SUB getUpdate
    DEFSTR szFileName = SPACE$(600) , szContent = "" , szDate = ""
    DEFLNG Upresult = 0
    DIM FileUp AS QFILESTREAM
    Upresult = URLDownloadToCacheFile(0 , "http://mitglied.multimania.de/vdobiasch/rapidqd.html" , szFileName , LEN(szFileName) , 0 , 0)
    IF Upresult <> 0 THEN Upresult = URLDownloadToCacheFile(0 , "http://vdobiasch.bplaced.net/VD/rapidqd.html" , szFileName , LEN(szFileName) , 0 , 0)
    IF Upresult = 0 THEN
        szFileName = RTRIM$(szFileName)
        FileUp.Open(szFileName , fmOpenRead)
        szContent = FileUp.ReadStr(FileUp.Size)
        FileUp.Close
        Upresult = INSTR(szContent , ">" + LTRIM$(myFormTitle) + "<")
        IF Upresult > 0 THEN
            szContent = MID$(szContent , Upresult)
            Upresult = INSTR(szContent , "&nbsp;&nbsp;")
            IF Upresult > 0 THEN
                szContent = MID$(szContent , Upresult + 12)
                szContent = LEFT$(szContent , INSTR(szContent + ")" , ")") - 1)
                szContent = REPLACESUBSTR$(szContent , "(" , "")
                szDate = REPLACESUBSTR$(FIELD$(szContent , "," , 2) , " " , "")
                szDate = MID$(szDate , 4 , 2) + "." + LEFT$(szDate , 2) + "." + RIGHT$(szDate , 4)
                IF ymd2scalar(VAL(RIGHT$(MyformBuild , 4)) , VAL(MID$(MyformBuild , 4 , 2)) , VAL(LEFT$(MyformBuild , 2))) < ymd2scalar(VAL(RIGHT$(szDate , 4)) , VAL(MID$(szDate , 4 , 2)) , VAL(LEFT$(szDate , 2))) THEN
                    MESSAGEBOX(Ini.get(Language , "NewVersionCaption" , "Es gibt eine neue Version im Internet !") + CHR$(13) + CHR$(10) + CHR$(10) + _
                        Ini.Get(Language , "NewVersion1Caption" , "Version") + " " + FIELD$(LTRIM$(szContent) , " " , 2) + " " + _
                        Ini.Get(Language , "NewVersion2Caption" , "vom") + " " + systemdate(1 , szDate) , LTRIM$(myFormTitle) + " - Update" , 48)
                ELSE
                    MESSAGEBOX(Ini.get(Language , "ActVersionCaption" , "Sie benutzen die aktuelle Version.") , LTRIM$(myFormTitle) + " - Update" , 64)
                END IF
            ELSE
                Upresult = 0
            END IF
        END IF
        IF Upresult = 0 THEN MESSAGEBOX(Ini.get(Language , "NoVersionCaption" , "Keine Versions-Info im Internet gefunden !") , LTRIM$(myFormTitle) + " - Update" , 16)
        KILL szFileName
    ELSE
        MESSAGEBOX(Ini.get(Language , "NoConnectCaption" , "Keine Verbindung zum Update-Server !") , LTRIM$(myFormTitle) + " - Update" , 16)
    END IF
END SUB

SUB AboutClick
    aboutlabel1.Font.Color = &h0070FF
    aboutlabel1.Font.bold = 1
    aboutAppName = LTRIM$(myFormTitle) + " - " + Ini.getraw(Language , "AboutFree" , "Dieses Programm ist Freeware.") + CHR$(13) + _
        "Copyright(c) 2005 - 2010 by V. Dobiasch" + CHR$(13) + Ini.getraw(Language , "AboutTranslate" , "Deutsche bersetzung von V. Dobiasch")
    aboutform.Caption = "   " + Ini.getraw(Language , "AboutCaption" , "ber") + " " + MyformName
          'LEFT$(MyformName , LEN(MyformName)- 3)+ " Version" + RIGHT$(MyformName , 3)
    aboutBuild = " (" + Ini.getraw(Language , "BuildOn" , "Erstellt am") + " " + systemdate(1 , MyformBuild) + ") "
    aboutText = Ini.Getraw(Language , "About1Text" , "Dieses Programm verschnert Ihren Quellcode.") + CHR$(13) + _
        Ini.Getraw(Language , "About2Text" , "(Einheitliche Schreibweise, Einrckungen usw.)") + CHR$(13) + CHR$(13) + _
        Ini.Getraw(Language , "About3Text" , "Kommandozeile: RQ-Pretty [Basic-Datei] [/QUIET]") + CHR$(13) + CHR$(13) + _
        Ini.Getraw(Language , "About4Text" , "Die Benutzung dieses Programms erfolgt auf eigene Gefahr !") + CHR$(13) + _
        Ini.Getraw(Language , "About5Text" , "Der Programmierer haftet niemals fr Schden oder Kosten.")
    aboutlogo.Transparent = True
    aboutimage.Transparent = True
    aboutimage.Icon = application.Icon
    aboutlogo.BMPHandle = Logo_bmp
    abouttranslate = "Translate ..."
    aboutBtTr.OnClick = Translate
    aboutUpdate = "Update ?"
    aboutBtUp.OnClick = getUpdate
    aboutEmail = "soft@vdobiasch.2ya.de"
    aboutEmail2 = "subject=" + MyformName
    aboutweb = "http://vdobiasch.2ya.de"
    aboutmirror1 = "http://www.vdobiasch.isfrom.de"
    aboutMiddleVert = Form.Top +(Form.Height / 2) + 35
    aboutMiddleHorz = Form.Left + Form.Width / 2 + 2
    aboutTop = Form.Top + 28
    aboutLeft = Form.Left + 6
          'aboutMaxHeight = Form.Height - 185
    aboutshow
    Focus
END SUB

SUB definition(test AS STRING , indicate AS STRING)
    FUNCTION Indikator(TestIn AS STRING) AS STRING
        SELECT CASE UCASE$(Testin)
            CASE "DBL"
                Testin = "DOUBLE"
            CASE "INT"
                Testin = "INTEGER"
            CASE "LNG"
                Testin = "LONG"
            CASE "SNG"
                Testin = "SINGLE"
            CASE "STR"
                Testin = "STRING"
                      'case "BYTE", "WORD", "DWORD", "SHORT"
                      'Testin=TestIn+" "
        END SELECT
        result = UCASE$(Testin) + " "
    END FUNCTION
    DEFLNG defa = INSTR(test , ",") , defb = INSTR(test , "=") , defc = 0
    DEFSTR indizw = LTRIM$(Indikator(indicate))
          'IF defa > 0 AND defb > defa THEN test = LEFT$(test , defa - 1)+ MID$(test , defb + 1)
          'messagebox(test,indicate,0)
    WHILE defa > 0
        TmpStr$ = LEFT$(test , defa - 1)
        IF defb > 0 THEN TmpStr$ = LEFT$(TmpStr$ , defb - 1)
        IF INSTR(UCASE$(TmpStr$) , " AS ") > 0 THEN TmpStr$ = LEFT$(TmpStr$ , INSTR(UCASE$(TmpStr$) , " AS "))
        PosStr$ = TmpStr$
        PosStr$ = REPLACESUBSTR$(PosStr$ , " " , "")
        IF INSTR(TmpStr$ , " ") > 0 THEN TmpStr$ = LEFT$(TmpStr$ , INSTR(TmpStr$ , " "))
        IF LEFT$(TmpStr$ , 1) <> " " THEN TmpStr$ = " " + TmpStr$
        IF RIGHT$(TmpStr$ , 1) <> " " THEN TmpStr$ = TmpStr$ + " "
        IF LTRIM$(TmpStr$) <> "" THEN
                  'showmessage("1"+Tmpstr$+"1")
            StrList.AddItems TmpStr$
            DimList.AddItems TmpStr$
                  'PosList.AddItems LTRIM$(RTRIM$(TmpStr$))
            defc = INSTR(UCASE$(test) , " AS ")
            PosList.AddItems IIF((indizw = "") AND (defc > 0) , UCASE$(MID$(test , defc + 4 , INSTR(defc + 4 , test , " ") - defc - 3)) + PosStr$ , indizw + PosStr$)
        END IF
              'showmessage(test)
        defb = INSTR(test , "(")
        defc = INSTR(test , ")")
        IF defb > 0 AND defb < defa AND defc > defa THEN
            test = LTRIM$(RIGHT$(test , LEN(test) - defc))
        ELSE
            defb = INSTR(test , "{")
            defc = INSTR(test , "}")
            IF defb > 0 AND defb < defa AND defc > defa THEN
                test = LTRIM$(RIGHT$(test , LEN(test) - defc))
            ELSE
                defb = INSTR(test , CHR$(34))
                IF defb > 0 THEN defc = INSTR(defb + 1 , test , CHR$(34))
                test = IIF((defb > 0) AND (defb < defa) AND (defc > defa) , LTRIM$(RIGHT$(test , LEN(test) - defc)) , LTRIM$(RIGHT$(test , LEN(test) - defa)))
            END IF
        END IF
        IF LEFT$(UCASE$(test) , 3) = "AS " THEN test = MID$(test , INSTR(4 , test , " ") + 1)
        defa = INSTR(test , ",")
        defb = INSTR(test , "=")
    WEND
    IF defb > 0 THEN test = LEFT$(test , defb - 1)
    TmpStr$ = test
    PosStr$ = test
    IF INSTR(UCASE$(TmpStr$) , " AS ") > 0 THEN TmpStr$ = LEFT$(TmpStr$ , INSTR(UCASE$(TmpStr$) , " AS ") - 1)
    PosStr$ = TmpStr$
    PosStr$ = REPLACESUBSTR$(PosStr$ , " " , "")
    IF INSTR(TmpStr$ , " ") > 0 THEN TmpStr$ = LEFT$(TmpStr$ , INSTR(TmpStr$ , " "))
    IF RIGHT$(TmpStr$ , 1) <> " " THEN TmpStr$ = TmpStr$ + " "
    IF LTRIM$(TmpStr$) <> "" THEN
              'messagebox(test,tmpstr$,0)
        StrList.AddItems " " + TmpStr$
        DimList.AddItems " " + TmpStr$
              'PosList.AddItems RTRIM$(test)
        defc = INSTR(UCASE$(test) , " AS ")
        PosList.AddItems IIF((indizw = "") AND (defc > 0) , UCASE$(MID$(test , defc + 4 , INSTR(defc + 4 , test , " ") - defc - 3)) + PosStr$ , indizw + PosStr$)
    END IF
END SUB

SUB Lstwrite(Name AS STRING)
    IF PosList.ItemCount > 0 THEN
        d = 0
        DO
            IF LEFT$(PosList.Item(d) , LEN(Name)) = Name THEN
                LstFile.WriteLine(IIF(TALLY(PosList.Item(d) , ",") < 2 , Ini.Get("RQpretty" , "Reminder" , "*!*") + "  " + PosList.Item(d) , PosList.Item(d)))
                PosList.DelItems d
            ELSE
                d ++
            END IF
        LOOP UNTIL d >= PosList.ItemCount
    END IF
END SUB

SUB StartBtnClick
    Timer1.Enabled = False
    Beautify = False
    IF Filename = "" THEN Filled = False
    IF TFilename = "" THEN Filled = False
    IF (BFilename = "") AND (CheckB.Checked) THEN Filled = False
    IF Filled THEN
        spacenumber = VAL(EditS.Text)
        IF spacenumber = 0 THEN spacenumber = 4
        Spacepart = SPACE$(spacenumber)

        spacenumberC = VAL(EditC.Text)
        IF spacenumberC = 0 THEN spacenumberC = 6
        StatusBar.Panel(0).Caption = "   " + Ini.Get(Language , "PrepareText" , "Bitte warten ... Bereite die Dateien vor")
        Form.Cursor = crHourGlass
        panelButton.Cursor = crHourGlass
        startbutton.Cursor = crHourGlass
        PanelRO.Cursor = crHourGlass
        LabelO.Cursor = crHourGlass
        PanelO.Cursor = crHourGlass
        LabelT.Cursor = crHourGlass
        PanelT.Cursor = crHourGlass
        LabelB.Cursor = crHourGlass
        PanelB.Cursor = crHourGlass
        PanelRS.Cursor = crHourGlass
        LabelS.Cursor = crHourGlass
        StatusBar.Cursor = crHourGlass
        LabelC.Cursor = crHourGlass
        buttonExit.Enabled = False
        Tschau.Enabled = False
        buttonOpen.Enabled = False
        OrgOpen.Enabled = False
        buttonSave.Enabled = False
        SaveOpen.Enabled = False
        buttonSaveAs.Enabled = False
        SaveAsOpen.Enabled = False
        startbutton.Enabled = False
        StrList.Clear
        DimList.Clear
        PosList.Clear

        checkkeylst :
        e$ = Command$(0)
        WHILE RIGHT$(e$ , 1) <> "." DO
            e$ = LEFT$(e$ , LEN(e$) - 1)
        WEND
        IF FILEEXISTS(e$ + "LST") = 0 THEN
            IF MESSAGEBOX(REPLACESUBSTR$(ListText , "%1%" , e$) , MyformName , 277) = mrCancel THEN
                Form.Close
            ELSE
                GOTO checkkeylst
            END IF
        END IF
        File.Open(e$ + "LST" , fmOpenRead)
        Beautify = True
        OneTab = False
        FOR a = 0 TO File.LineCount
            Line1 = File.ReadLine
            Line1 = LTRIM$(RTRIM$(Line1))
            b = INSTR(Line1 , CHR$(39))
            IF b THEN
                Line1 = LEFT$(Line1 , b - 1)
                Line1 = RTRIM$(Line1)
            END IF
            IF LEN(Line1) THEN StrList.AddItems " " + Line1 + " "
        NEXT
        File.Close

        File.Open(Filename , fmOpenRead)
        Line1 = File.ReadStr(File.Size)
        File.Close

        Line1 = SubstSubstr(Line1 , CHR$(9) , Spacepart , False)
        Killspaces "^"
        Killspaces "["
        Killspaces "]"
              'LogFile.Open("c:\log.txt" , fmCreate)
        mem.Clear
        mem1.Clear
        mem.Write Line1
        mem.Seek 0 , soFromBeginning
        LC = mem.LineCount
        FOR a = 0 TO LC
            StatusBar.Panel(0).Caption = "   " + REPLACESUBSTR$(REPLACESUBSTR$(RunText , "%1%" , STR$(a)) , "%2%" , STR$(LC))
            DOEVENTS
            Commentpart = ""
            Line1 = mem.ReadLine
            Line1 = LTRIM$(RTRIM$(Line1))
            b = INSTR(Line1 , CHR$(39))
            c = INSTR(Line1 , CHR$(34))
            WHILE c > 0 AND c < b AND INSTR(c + 1 , Line1 , CHR$(34)) > 0
                c = INSTR(c + 1 , Line1 , CHR$(34))
                b = INSTR(c , Line1 , CHR$(39))
            WEND
            IF b THEN
                c = LEN(Line1)
                Commentpart = MID$(Line1 , b , c - b + 1)
                Line1 = LEFT$(Line1 , b - 1)
                Line1 = RTRIM$(Line1) + " "
                Commentpart = SPACE$(spacenumberC) + REPLACESUBSTR$(Commentpart , CHR$(39) + CHR$(39) , CHR$(39))
                WHILE MID$(Commentpart , INSTR(Commentpart , CHR$(39)) + 1 , 1) = " "
                    Commentpart = LEFT$(Commentpart , INSTR(Commentpart , CHR$(39))) + MID$(Commentpart , INSTR(Commentpart , CHR$(39)) + 2 , LEN(Commentpart))
                WEND
            END IF
            Killspaces " "
            WHILE LEFT$(Line1 , 1) = CHR$(9)
                Line1 = MID$(Line1 , 2)
            WEND
            Killspaces ","
            Line1 = SubstSubstr(Line1 , "," , " , " , False)
            Killspaces "-"
            Line1 = SubstSubstr(Line1 , "-" , " - " , False)
            Killspaces "+"
            Line1 = SubstSubstr(Line1 , "+" , " + " , False)
            Killspaces "*"
            Line1 = SubstSubstr(Line1 , "*" , " * " , False)
            Killspaces "/"
            Line1 = SubstSubstr(Line1 , "/" , " / " , False)
            Killspaces "="
            Line1 = SubstSubstr(Line1 , "=" , " = " , False)
            Killspaces "<"
            Line1 = SubstSubstr(Line1 , "<" , " < " , False)
            Killspaces ">"
            Line1 = SubstSubstr(Line1 , ">" , " > " , False)
            Killspaces "\"
            Line1 = SubstSubstr(Line1 , "\" , " \ " , False)
            Killspaces "("
            Line1 = SubstSubstr(Line1 , "(" , " ( " , False)
            Killspaces ")"
            Line1 = SubstSubstr(Line1 , ")" , " ) " , False)
            Killspaces "."
            Line1 = SubstSubstr(Line1 , "." , " . " , False)
            Killspaces ":"
            DOEVENTS
            Line1 = " " + Line1 + " "
            IF UCASE$(LEFT$(Line1 , 5)) = " DIM " THEN
                definition(LTRIM$(MID$(Line1 , 6)) , "")
            ELSEIF UCASE$(LEFT$(Line1 , 8)) = " STATIC " THEN
                StrList.AddItems " " + MID$(Line1 , 9 , INSTR(9 , Line1 , " ") - 9) + " "
                DimList.AddItems " " + MID$(Line1 , 9 , INSTR(9 , Line1 , " ") - 9) + " "
                d = INSTR(UCASE$(Line1) , " AS ")
                PosList.AddItems IIF(d > 6 , "STATIC " + MID$(Line1 , d + 4) + MID$(Line1 , 6 , d - 6) , "STATIC " + MID$(Line1 , 6 , INSTR(6 , Line1 , " ") - 6))
            ELSEIF UCASE$(LEFT$(Line1 , 7)) = " CONST " THEN
                definition(LTRIM$(MID$(Line1 , 8)) , "CONST")
            ELSEIF INSTR(" DEFDBL DEFINT DEFLNG DEFSNG DEFSTR " , UCASE$(LEFT$(Line1 , 8))) > 0 THEN
                definition(LTRIM$(MID$(Line1 , 9)) , MID$(Line1 , 5 , 3))
            ELSEIF INSTR(" DEFBYTE DEFWORD " , UCASE$(LEFT$(Line1 , 9))) > 0 THEN
                definition(LTRIM$(MID$(Line1 , 10)) , MID$(Line1 , 5 , 4))
            ELSEIF INSTR(" DEFDWORD DEFSHORT " , UCASE$(LEFT$(Line1 , 10))) > 0 THEN
                definition(LTRIM$(MID$(Line1 , 11)) , MID$(Line1 , 5 , 5))
            ELSEIF UCASE$(LEFT$(Line1 , 6)) = " TYPE " THEN
                StrList.AddItems " " + MID$(Line1 , 7 , INSTR(7 , Line1 , " ") - 7) + " "
            ELSEIF UCASE$(LEFT$(Line1 , 8)) = " CREATE " THEN
                StrList.AddItems " " + MID$(Line1 , 9 , INSTR(9 , Line1 , " ") - 9) + " "
            ELSEIF UCASE$(LEFT$(Line1 , 11)) = " $RESOURCE " THEN
                StrList.AddItems " " + MID$(Line1 , 12 , INSTR(12 , Line1 , " ") - 12) + " "
                DimList.AddItems " " + MID$(Line1 , 12 , INSTR(12 , Line1 , " ") - 12) + " "
                PosList.AddItems "RESOURCE " + MID$(Line1 , 12 , INSTR(12 , Line1 , " ") - 12) + " "
            ELSEIF UCASE$(LEFT$(Line1 , 13)) = " DECLARE SUB " THEN
                StrList.AddItems " " + MID$(Line1 , 14 , INSTR(14 , Line1 , " ") - 14) + " "
                DimList.AddItems " " + MID$(Line1 , 14 , INSTR(14 , Line1 , " ") - 14) + " "
                PosList.AddItems "SUB " + MID$(Line1 , 14 , INSTR(14 , Line1 , " ") - 14)
            ELSEIF UCASE$(LEFT$(Line1 , 14)) = " DECLARE SUBI " THEN
                StrList.AddItems " " + MID$(Line1 , 15 , INSTR(15 , Line1 , " ") - 15) + " "
                DimList.AddItems " " + MID$(Line1 , 15 , INSTR(15 , Line1 , " ") - 15) + " "
                PosList.AddItems "SUBI " + MID$(Line1 , 15 , INSTR(15 , Line1 , " ") - 15)
            ELSEIF UCASE$(LEFT$(Line1 , 18)) = " DECLARE FUNCTION " THEN
                StrList.AddItems " " + MID$(Line1 , 19 , INSTR(19 , Line1 , " ") - 19) + " "
                DimList.AddItems " " + MID$(Line1 , 19 , INSTR(19 , Line1 , " ") - 19) + " "
                PosList.AddItems "FUNCTION " + MID$(Line1 , 19 , INSTR(19 , Line1 , " ") - 19)
            ELSEIF UCASE$(LEFT$(Line1 , 19)) = " DECLARE FUNCTIONI " THEN
                StrList.AddItems " " + MID$(Line1 , 20 , INSTR(20 , Line1 , " ") - 20) + " "
                DimList.AddItems " " + MID$(Line1 , 20 , INSTR(20 , Line1 , " ") - 20) + " "
                PosList.AddItems "FUNCTIONI " + MID$(Line1 , 20 , INSTR(20 , Line1 , " ") - 20)
            END IF
            TmpStr$ = UCASE$(Line1)
            FOR d = 0 TO StrList.ItemCount - 1
                IF INSTR(TmpStr$ , UCASE$(StrList.Item(d))) > 0 THEN
                    Line1 = SubstSubstr(Line1 , StrList.Item(d) , StrList.Item(d) , True)
                    gef = 1
                END IF
            NEXT d
            DOEVENTS
            Teststr = ""
            IF UCASE$(LEFT$(Line1 , 5)) = " SUB " THEN
                Teststr = " " + MID$(Line1 , 6 , INSTR(6 , Line1 , " ") - 6) + " "
            ELSEIF UCASE$(LEFT$(Line1 , 6)) = " SUBI " THEN
                Teststr = " " + MID$(Line1 , 7 , INSTR(7 , Line1 , " ") - 7) + " "
            ELSEIF UCASE$(LEFT$(Line1 , 10)) = " FUNCTION " THEN
                Teststr = " " + MID$(Line1 , 11 , INSTR(11 , Line1 , " ") - 11) + " "
            ELSEIF UCASE$(LEFT$(Line1 , 11)) = " FUNCTIONI " THEN
                Teststr = " " + MID$(Line1 , 12 , INSTR(12 , Line1 , " ") - 12) + " "
            END IF
            gef = 0
            FOR d = 0 TO DimList.ItemCount - 1
                IF INSTR(Line1 , DimList.Item(d)) > 0 THEN PosList.Item(d) = PosList.Item(d) + ", " + STR$(a + 1)
                IF Teststr <> "" AND DimList.Item(d) = Teststr THEN gef = 1
            NEXT
            IF gef = 0 THEN
                IF UCASE$(LEFT$(Line1 , 5)) = " SUB " THEN
                    StrList.AddItems " " + MID$(Line1 , 6 , INSTR(6 , Line1 , " ") - 6) + " "
                    DimList.AddItems " " + MID$(Line1 , 6 , INSTR(6 , Line1 , " ") - 6) + " "
                    PosList.AddItems "SUB " + MID$(Line1 , 6 , INSTR(6 , Line1 , " ") - 6) + ", " + STR$(a + 1)
                ELSEIF UCASE$(LEFT$(Line1 , 6)) = " SUBI " THEN
                    StrList.AddItems " " + MID$(Line1 , 7 , INSTR(7 , Line1 , " ") - 7) + " "
                    DimList.AddItems " " + MID$(Line1 , 7 , INSTR(7 , Line1 , " ") - 7) + " "
                    PosList.AddItems "SUBI " + MID$(Line1 , 7 , INSTR(7 , Line1 , " ") - 7) + ", " + STR$(a + 1)
                ELSEIF UCASE$(LEFT$(Line1 , 10)) = " FUNCTION " THEN
                    StrList.AddItems " " + MID$(Line1 , 11 , INSTR(11 , Line1 , " ") - 11) + " "
                    DimList.AddItems " " + MID$(Line1 , 11 , INSTR(11 , Line1 , " ") - 11) + " "
                    PosList.AddItems "FUNCTION " + MID$(Line1 , 11 , INSTR(11 , Line1 , " ") - 11) + ", " + STR$(a + 1)
                ELSEIF UCASE$(LEFT$(Line1 , 11)) = " FUNCTIONI " THEN
                    StrList.AddItems " " + MID$(Line1 , 12 , INSTR(12 , Line1 , " ") - 12) + " "
                    DimList.AddItems " " + MID$(Line1 , 12 , INSTR(12 , Line1 , " ") - 12) + " "
                    PosList.AddItems "FUNCTIONI " + MID$(Line1 , 12 , INSTR(12 , Line1 , " ") - 12) + ", " + STR$(a + 1)
                ELSEIF UCASE$(LEFT$(Line1 , 14)) = " PROPERTY SET " THEN
                    StrList.AddItems " " + MID$(Line1 , 15 , INSTR(15 , Line1 , " ") - 15) + " "
                    DimList.AddItems " " + MID$(Line1 , 15 , INSTR(15 , Line1 , " ") - 15) + " "
                    PosList.AddItems "PROPERTY SET " + MID$(Line1 , 15 , INSTR(15 , Line1 , " ") - 15) + ", " + STR$(a + 1)
                END IF
            END IF
            Killspaces "("
            Killspaces ") "
            Killspaces "."
            Line1 = SubstSubstr(Line1 , ") )" , "))" , False)
            Line1 = SubstSubstr(Line1 , "+  +" , "++" , False)
            Line1 = SubstSubstr(Line1 , "-  -" , "--" , False)
            Line1 = SubstSubstr(Line1 , ") )" , "))" , False)
            Line1 = SubstSubstr(Line1 , "< >" , "<>" , False)
            Line1 = SubstSubstr(Line1 , "< =" , "<=" , False)
            Line1 = SubstSubstr(Line1 , "> =" , ">=" , False)
            Line1 = SubstSubstr(Line1 , "=(" , "= (" , False)
            Line1 = SubstSubstr(Line1 , "<(" , "< (" , False)
            Line1 = SubstSubstr(Line1 , ">(" , "> (" , False)
            Line1 = SubstSubstr(Line1 , "=(" , "= (" , False)
            Line1 = SubstSubstr(Line1 , "+(" , "+ (" , False)
            Line1 = SubstSubstr(Line1 , "-(" , "- (" , False)
            Line1 = SubstSubstr(Line1 , "*(" , "* (" , False)
            Line1 = SubstSubstr(Line1 , "/(" , "/ (" , False)
            Line1 = SubstSubstr(Line1 , "\(" , "\ (" , False)
            Line1 = SubstSubstr(Line1 , "&(" , "& (" , False)
            Line1 = SubstSubstr(Line1 , ",(" , ", (" , False)            
            Line1 = SubstSubstr(Line1 , "<." , "< ." , False)
            Line1 = SubstSubstr(Line1 , ">." , "> ." , False)
            Line1 = SubstSubstr(Line1 , "=." , "= ." , False)
            Line1 = SubstSubstr(Line1 , "+." , "+ ." , False)
            Line1 = SubstSubstr(Line1 , "-." , "- ." , False)
            Line1 = SubstSubstr(Line1 , "*." , "* ." , False)
            Line1 = SubstSubstr(Line1 , "/." , "/ ." , False)
            Line1 = SubstSubstr(Line1 , "\." , "\ ." , False)
            Line1 = SubstSubstr(Line1 , "&." , "& ." , False)
            Line1 = SubstSubstr(Line1 , ",." , ", ." , False)
            Line1 = SubstSubstr(Line1 , " IF(" , " IF (" , True)
            Line1 = SubstSubstr(Line1 , " IF." , " IF ." , True)
            Line1 = SubstSubstr(Line1 , " THEN(" , " THEN (" , True)
            Line1 = SubstSubstr(Line1 , " THEN." , " THEN ." , True)
            Line1 = SubstSubstr(Line1 , " ELSE(" , " ELSE (" , True)
            Line1 = SubstSubstr(Line1 , " ELSE." , " ELSE ." , True)
            Line1 = SubstSubstr(Line1 , " ELSEIF(" , " ELSEIF (" , True)
            Line1 = SubstSubstr(Line1 , " ELSEIF." , " ELSEIF ." , True)
            Line1 = SubstSubstr(Line1 , " AND(" , " AND (" , True)
            Line1 = SubstSubstr(Line1 , " NOT(" , " NOT (" , True)
            Line1 = SubstSubstr(Line1 , " OR(" , " OR (" , True)
            Line1 = SubstSubstr(Line1 , " XOR(" , " XOR (" , True)
            Line1 = SubstSubstr(Line1 , " SHL(" , " SHL (" , True)
            Line1 = SubstSubstr(Line1 , " SHR(" , " SHR (" , True)
            Line1 = SubstSubstr(Line1 , " MOD(" , " MOD (" , True)
            Line1 = SubstSubstr(Line1 , " INV(" , " INV (" , True)
            Line1 = SubstSubstr(Line1 , " WHILE(" , " WHILE (" , True)
            Line1 = SubstSubstr(Line1 , " DO(" , " DO (" , True)
            Line1 = SubstSubstr(Line1 , " LOOP(" , " LOOP (" , True)
            Line1 = SubstSubstr(Line1 , " UNTIL(" , " UNTIL (" , True)
            Line1 = SubstSubstr(Line1 , " FOR(" , " FOR (" , True)
            Line1 = SubstSubstr(Line1 , " CASE(" , " CASE (" , True)
            Line1 = SubstSubstr(Line1 , " AND." , " AND ." , True)
            Line1 = SubstSubstr(Line1 , " NOT." , " NOT ." , True)
            Line1 = SubstSubstr(Line1 , " OR." , " OR ." , True)
            Line1 = SubstSubstr(Line1 , " XOR." , " XOR ." , True)
            Line1 = SubstSubstr(Line1 , " SHL." , " SHL ." , True)
            Line1 = SubstSubstr(Line1 , " SHR." , " SHR ." , True)
            Line1 = SubstSubstr(Line1 , " MOD." , " MOD ." , True)
            Line1 = SubstSubstr(Line1 , " INV." , " INV ." , True)
            Line1 = SubstSubstr(Line1 , " WHILE." , " WHILE ." , True)
            Line1 = SubstSubstr(Line1 , " DO." , " DO ." , True)
            Line1 = SubstSubstr(Line1 , " LOOP." , " LOOP ." , True)
            Line1 = SubstSubstr(Line1 , " UNTIL." , " UNTIL ." , True)
            Line1 = SubstSubstr(Line1 , " FOR." , " FOR ." , True)
            Line1 = SubstSubstr(Line1 , " CASE." , " CASE ." , True)
            Line1 = SubstSubstr(Line1 , ":" , " : " , False)
            Line1 = LTRIM$(Line1)
            b = INSTR(Line1 , " ")
            e$ = UCASE$(LEFT$(Line1 , b - 1))
                  'LogFile.WriteLine("Line1:"+Line1)
                  'LogFile.WriteLine(e$)
            DOEVENTS
            SELECT CASE e$
                CASE "CREATE" , "DO" , "FOR" , "TYPE" , "SUB" , "SUBI" , "FUNCTION" , _
                        "FUNCTIONI" , "PROPERTY" , "WHILE" , "CONSTRUCTOR" , "WITH" , "EVENT"
                    mem1.WriteLine Tabpart + Line1 + Commentpart
                          'Line1 = SubstSubstr(Line1 , " : " , " : " , False)
                    IF SubStrFound = 0 THEN Tabpart = Tabpart + Spacepart
                CASE "SELECT"
                    mem1.WriteLine Tabpart + Line1 + Commentpart
                    Tabpart = Tabpart + Spacepart + Spacepart
                CASE "IF" , "$IFDEF" , "$IFNDEF"
                    mem1.WriteLine Tabpart + Line1 + Commentpart
                    IF UCASE$(RIGHT$(RTRIM$(Line1) , 4)) = "THEN" OR LEFT$(e$ , 3) = "$IF" THEN Tabpart = Tabpart + Spacepart
                CASE "LOOP" , "NEXT" , "WEND"
                    Tabpart = LEFT$(Tabpart , LEN(Tabpart) - spacenumber)
                    mem1.WriteLine Tabpart + Line1 + Commentpart
                CASE "END" , "$ENDIF"
                    IF RTRIM$(Line1) <> "END" THEN
                        Tabpart = LEFT$(Tabpart , LEN(Tabpart) - spacenumber)
                        IF INSTR(Line1 , "SELECT") THEN Tabpart = LEFT$(Tabpart , LEN(Tabpart) - spacenumber)
                        mem1.WriteLine Tabpart + Line1 + Commentpart
                    ELSE
                        mem1.WriteLine Tabpart + Line1 + Commentpart
                    END IF
                CASE "CASE"
                    Tabpart = LEFT$(Tabpart , LEN(Tabpart) - spacenumber)
                    mem1.WriteLine Tabpart + Line1 + Commentpart
                    Tabpart = Tabpart + Spacepart
                CASE "ELSE" , "$ELSE"
                    Tabpart = LEFT$(Tabpart , LEN(Tabpart) - spacenumber)
                    mem1.WriteLine Tabpart + Line1 + Commentpart
                    Tabpart = Tabpart + Spacepart
                CASE "ELSEIF"
                    Tabpart = LEFT$(Tabpart , LEN(Tabpart) - spacenumber)
                    mem1.WriteLine Tabpart + Line1 + Commentpart
                    IF UCASE$(RIGHT$(RTRIM$(Line1) , 4)) = "THEN" THEN Tabpart = Tabpart + Spacepart
                CASE "PUBLIC:" , "PRIVATE:"
                    mem1.WriteLine Line1 + Commentpart
                CASE ELSE
                    mem1.WriteLine Tabpart + Line1 + Commentpart
            END SELECT
            IF OneTab = True THEN
                IF UCASE$(RIGHT$(RTRIM$(Line1) , 4)) <> "THEN" THEN
                    Tabpart = LEFT$(Tabpart , LEN(Tabpart) - spacenumber)
                    OneTab = False
                END IF
            END IF
            IF RIGHT$(RTRIM$(Line1) , 1) = "_" THEN
                OneTab = True
                Tabpart = Tabpart + Spacepart
            ELSE
                OneTab = False
            END IF
        NEXT a
        StatusBar.Panel(0).Caption = "   " + Ini.Get(Language , "SaveText" , "Bitte warten ... Speichere berarbeitete Datei")

        mem1.Seek 0 , soFromBeginning
        IF CheckB.Checked THEN
            IF FILEEXISTS(BFilename) THEN KILL BFilename
            RENAME Filename , BFilename
        END IF
        c = 0
        File.Open(TFilename , fmCreate)
        FOR a = 0 TO LC
            Line1 = ""
            Line1 = mem1.ReadLine
            c = IIF(RTRIM$(Line1) = "" , c + 1 , 0)
            IF c < 3 THEN File.WriteLine RTRIM$(Line1)
        NEXT
        File.Close
        IF CheckL.Checked THEN
            LstFile.Open(TFilename + ".LST" , fmCreate)
            Lstwrite("FUNCTION ")
            Lstwrite("FUNCTIONI ")
            Lstwrite("SUB ")
            Lstwrite("SUBI ")
            Lstwrite("PROPERTY ")
            Lstwrite("CONST ")
            Lstwrite("BYTE ")
            Lstwrite("SHORT ")
            Lstwrite("WORD ")
            Lstwrite("DWORD ")
            Lstwrite("INTEGER ")
            Lstwrite("LONG ")
            Lstwrite("SINGLE ")
            Lstwrite("DOUBLE ")
            Lstwrite("STRING ")
            IF PosList.ItemCount > 0 THEN
                FOR d = 0 TO PosList.ItemCount - 1
                    LstFile.WriteLine(IIF(TALLY(PosList.Item(d) , ",") < 2 , Ini.Get("RQpretty" , "Reminder" , "*!*") + "  " + PosList.Item(d) , PosList.Item(d)))
                NEXT
            END IF
            LstFile.Close
        END IF
        mem.Close
        mem1.Close
        Beautify = False
              'LogFile.Close

              'LogFile.Open("c:\key.txt" , fmCreate)
              'FOR d = 0 TO StrList.ItemCount - 1
              'LogFile.WriteLine(StrList.Item(d))
              'NEXT d
              'LogFile.Close

        Form.Cursor = crDefault
        panelButton.Cursor = crDefault
        startbutton.Cursor = crDefault
        PanelRO.Cursor = crDefault
        LabelO.Cursor = crDefault
        PanelO.Cursor = crDefault
        LabelT.Cursor = crDefault
        PanelT.Cursor = crDefault
        LabelB.Cursor = crDefault
        PanelB.Cursor = crDefault
        PanelRS.Cursor = crDefault
        LabelS.Cursor = crDefault
        StatusBar.Cursor = crDefault
        LabelC.Cursor = crDefault
        buttonExit.Enabled = True
        Tschau.Enabled = True
        buttonOpen.Enabled = True
        OrgOpen.Enabled = True
        buttonSave.Enabled = True
        SaveOpen.Enabled = True
        buttonSaveAs.Enabled = True
        SaveAsOpen.Enabled = True
        startbutton.Enabled = True
        StatusBar.Panel(0).Caption = "   " + Ini.Get(Language , "DoneText" , "Fertig.")
        IF Automatik = True THEN Form.Close
    END IF
    SetFocus(buttonExit.Handle)
END SUB

SUB Killspaces(t$ AS STRING)
    Line1 = SubstSubstr(Line1 , " " + t$ , t$ , False)
    Line1 = SubstSubstr(Line1 , t$ + " " , t$ , False)
END SUB

FUNCTION SubstSubstr(byref Mainstring AS STRING , Orgstring AS STRING , Sparestring AS STRING , BigL AS INTEGER) AS STRING
    DIM fund1 AS LONG
    DIM afz1 AS LONG
    DIM afz2 AS LONG
    DIM safz AS LONG
    DIM zw1 AS STRING

    zw1 = Mainstring
    fund1 = IIF(BigL = True , INSTR(UCASE$(zw1) , UCASE$(Orgstring)) , INSTR(zw1 , Orgstring))
    safz = 1
    SubStrFound = 0
    WHILE fund1 > 0 DO
        afz1 = INSTR(safz , zw1 , CHR$(34))
        IF afz1 = 0 THEN
            afz1 = 99999999
            afz2 = 99999999
        ELSE
            afz2 = INSTR(afz1 + 1 , zw1 , CHR$(34))
            IF afz2 = 0 THEN afz2 = 99999999
        END IF
        IF fund1 < afz1 THEN
            zw1 = LEFT$(Mainstring , fund1 - 1) + Sparestring + RIGHT$(Mainstring , LEN(Mainstring) - LEN(Orgstring) - fund1 + 1)
            SubStrFound ++
            Mainstring = zw1
            fund1 = IIF(BigL = True , INSTR(fund1 + LEN(Sparestring) , UCASE$(zw1) , UCASE$(Orgstring)) , INSTR(fund1 + LEN(Sparestring) , zw1 , Orgstring))
        ELSE
            safz = afz2 + 1
            fund1 = IIF(Bigl = True , INSTR(safz , UCASE$(zw1) , UCASE$(Orgstring)) , INSTR(safz , zw1 , Orgstring))
        END IF
    WEND
    SubstSubstr = zw1
END FUNCTION

